<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN" [
<!ENTITY missing-standard-procedures system "std-proc.dsl">
]>

<style-specification>

; parameters 

(define bibkey-style "numeric")
(define bibkey-open "[")
(define bibkey-close "]")

(define (bibkey snl) 
  (string-append 
   bibkey-open
   (case bibkey-style		  
     (("full-id") (attribute-string "ID" snl))
     (("short-id") (substring (attribute-string "ID" snl) 0 3))
     (("numeric") (number->string (+ 1 (node-list-length (preced snl))))))
   bibkey-close))

; construction rules

(root 
 (case (gi (node-property 'docelem (current-node)))
   (("DOC1") (error "I can only work on documents of type DOC2."))
   (("DOC2") (process-children))))

(element DOC2
  (make simple-page-sequence
	left-margin: 1in
	right-margin: 1in
	top-margin: 1in
	bottom-margin: 1in
	(process-children)))

(element P
  (make paragraph
	(process-children)))

(element BIBREF
  (if (attribute-string "NOCITE") (empty-sosofo)
      (make sequence
	    (literal (bibkey (element-with-id (attribute-string "CITE")))))))
  
(element REFERENCES
  (make sequence
	(make paragraph 
	      font-size: 12pt
	      font-weight: 'bold
	      space-before: 0.5cm
	      space-after: 0.2cm
	      (literal "References"))
	(process-children)))

(element BOOK
  (make paragraph 
	(literal (bibkey (current-node))) 
	(literal " ")
	(process-matching-children 'author)
	(literal ", ")
	(make sequence
	      font-posture: 'italic
	      (process-matching-children 'title))))
  
(element ARTICLE
  (make paragraph
	(literal (bibkey (current-node))) 
	(literal " ")
	(process-matching-children 'author)
	(literal ", ")
	(make sequence
	      font-posture: 'upright
	      (process-matching-children 'title))))

</style-specification>
